/*
 * wnix, a Unix-like operating system for WebAssembly applications.
 * Copyright (C) 2025  Xavier Del Campo Romero
 *
 * This program is free software: you can redistribute it and/or modify
 * it under the terms of the GNU Affero General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU Affero General Public License for more details.
 *
 * You should have received a copy of the GNU Affero General Public License
 * along with this program.  If not, see <https://www.gnu.org/licenses/>.
 */

#include <bin/proc.h>
#include <bin/types.h>
#include <page.h>
#include <kprintf.h>
#include <stddef.h>

int bin_proc_s_pop(void *const dst, size_t n, void *const user)
{
    struct bin_proc *const p = user;
    struct bin_stack *const s = &p->stack;
    unsigned long addr;

    if (!s->page || n > s->sz)
    {
        kprintf("%s: stack underflow\n", p->path);
        return -1;
    }
    else if (s->pi)
    {
        const size_t rem = s->n - s->pi;

        if (n > rem)
            n = rem;

        addr = s->sz - rem;
    }
    else
        addr = s->sz - n;

    const int r = page_read(&s->page, addr, dst, n);

    if (r < 0)
        return -1;
    else if (r != n)
    {
        s->pi += r;
        s->n = n;
        return r;
    }
    else if (page_shrink(&s->page, addr))
        return -1;

    s->sz -= s->n ? s->n : n;
    s->n = s->pi = 0;
    return r;
}
